#
# HaloDemoTrainer.py
#
# Created by nil
# Copyright (c) 2009. All rights reserved.

from VirtualMemory import *
from Debug import *
from Settings import *
import random


WINDOW_TITLE = "002's Teleporter"
DESCRIPTION = "Just say \"sv_tele\" or \"tele\" to teleport.\n\nWarning: Do not play in CTF. This will cause the red flag in CTF to vanish, making CTF for blue team impossible to win. It will also cause the blue machine gun warthog to not appear in Slayer."
EXECUTION_TIME_INTERVAL = 0.5

#Halo Demo constants
FIRST_STATIC_PLAYER_ADDRESS = 0x4BD7AFD0
STATIC_PLAYER_SIZE = 0x200
TEAM_INDEX_OFFSET = 0x1E
PLAYER_OBJECT_ID_OFFSET = 0x32
INVALID_PLAYER_OBJECT_ID = 0xFFFF
OFFSET_TO_PLAYER_VEHICLE_ID = 0x11E

FIRST_TABLE_OBJECT_ADDRESS = 0x4BB206EC
OBJECT_TABLE_SIZE = 12
OFFSET_TO_HALO_OBJECT_POINTER = 0x8

OFFSET_TO_PLAYER_X_COORDINATE = 0x5C
OFFSET_TO_PLAYER_Y_COORDINATE = 0x60
OFFSET_TO_PLAYER_Z_COORDINATE = 0x64

BLUE_WARTHOG_SLAYER_Z_POSITION_ADDRESS = 0x4BB267A0 			#What the hell is wrong with the blue machine gun warthog? It really screws up a lot of things. I'm going to have it temporarily removed.

MOST_RECENT_MESSAGE_ADDRESS = 0x4BAD03C4

MAX_HALO_PLAYERS = 16

def execute(timeElapsed):
#	if DISABLE_BLUE_MG_HOG_SUPPRESSOR != 1: writeFloat(BLUE_WARTHOG_SLAYER_Z_POSITION_ADDRESS,-100)		#Damn you, blue machine gun warthog.
	mostRecentMessage = readUTF16String(MOST_RECENT_MESSAGE_ADDRESS)
	if timeElapsed == 0:
		player1RCoord = [0,0,0]
		player2RCoord = [0,0,0]
		player3RCoord = [0,0,0]
		player4RCoord = [0,0,0]
		player5RCoord = [0,0,0]
		player6RCoord = [0,0,0]
		player7RCoord = [0,0,0]
		player8RCoord = [0,0,0]
		player9RCoord = [0,0,0]
		player10RCoord = [0,0,0]
		player11RCoord = [0,0,0]
		player12RCoord = [0,0,0]
		player13RCoord = [0,0,0]
		player14RCoord = [0,0,0]
		player15RCoord = [0,0,0]
		player16RCoord = [0,0,0]
		global player1RCoord
		global player2RCoord
		global player3RCoord
		global player4RCoord
		global player5RCoord
		global player6RCoord
		global player7RCoord
		global player8RCoord
		global player9RCoord
		global player10RCoord
		global player11RCoord
		global player12RCoord
		global player13RCoord
		global player14RCoord
		global player15RCoord
		global player16RCoord
	if timeElapsed % 20 == 0:
		for playerIndex in range(0,MAX_HALO_PLAYERS):
			playerObjectID = readUInt16(FIRST_STATIC_PLAYER_ADDRESS + PLAYER_OBJECT_ID_OFFSET + STATIC_PLAYER_SIZE * playerIndex)
			playerAddress = readUInt32(FIRST_TABLE_OBJECT_ADDRESS + OBJECT_TABLE_SIZE * playerObjectID + OFFSET_TO_HALO_OBJECT_POINTER)
			if playerObjectID != 0 and playerObjectID != INVALID_PLAYER_OBJECT_ID:
				if readUInt16(playerAddress + OFFSET_TO_PLAYER_VEHICLE_ID) == INVALID_PLAYER_OBJECT_ID:
					cX = readFloat(playerAddress + OFFSET_TO_PLAYER_X_COORDINATE)
					cY = readFloat(playerAddress + OFFSET_TO_PLAYER_Y_COORDINATE)
					cZ = readFloat(playerAddress + OFFSET_TO_PLAYER_Z_COORDINATE)
					thisCoord = [cX,cY,cZ]
					if playerIndex == 0:
						player1RCoord = thisCoord
					if playerIndex == 1:
						player2RCoord = thisCoord
					if playerIndex == 2:
						player3RCoord = thisCoord
					if playerIndex == 3:
						player4RCoord = thisCoord
					if playerIndex == 4:
						player5RCoord = thisCoord
					if playerIndex == 5:
						player6RCoord = thisCoord
					if playerIndex == 6:
						player7RCoord = thisCoord
					if playerIndex == 7:
						player8RCoord = thisCoord
					if playerIndex == 8:
						player9RCoord = thisCoord
					if playerIndex == 9:
						player10RCoord = thisCoord
					if playerIndex == 10:
						player11RCoord = thisCoord
					if playerIndex == 11:
						player12RCoord = thisCoord
					if playerIndex == 12:
						player13RCoord = thisCoord
					if playerIndex == 13:
						player14RCoord = thisCoord
					if playerIndex == 14:
						player15RCoord = thisCoord
					if playerIndex == 15:
						player16RCoord = thisCoord
	for playerIndex in range(0,MAX_HALO_PLAYERS):
		if mostRecentMessage == readUTF16String(FIRST_STATIC_PLAYER_ADDRESS + STATIC_PLAYER_SIZE*playerIndex) + ": tele" or mostRecentMessage == readUTF16String(FIRST_STATIC_PLAYER_ADDRESS + STATIC_PLAYER_SIZE*playerIndex) + ": sv_tele":
			playerObjectID = readUInt16(FIRST_STATIC_PLAYER_ADDRESS + PLAYER_OBJECT_ID_OFFSET + STATIC_PLAYER_SIZE * playerIndex)
			playerAddress = readUInt32(FIRST_TABLE_OBJECT_ADDRESS + OBJECT_TABLE_SIZE * playerObjectID + OFFSET_TO_HALO_OBJECT_POINTER)
			if playerObjectID != 0 and playerObjectID != INVALID_PLAYER_OBJECT_ID:
				if player1RCoord == [0,0,0] and player2RCoord == [0,0,0] and player3RCoord == [0,0,0] and player4RCoord == [0,0,0] and player5RCoord == [0,0,0] and player6RCoord == [0,0,0] and player7RCoord == [0,0,0] and player8RCoord == [0,0,0] and player9RCoord == [0,0,0] and player10RCoord == [0,0,0] and player11RCoord == [0,0,0] and player12RCoord == [0,0,0] and player13RCoord == [0,0,0] and player14RCoord == [0,0,0] and player15RCoord == [0,0,0] and player16RCoord == [0,0,0]:
					writeUTF16String(MOST_RECENT_MESSAGE_ADDRESS,"There's nowhere to teleport. Wait a while.")
				else:
					x = -1
					while x == -1:
						y = random.randint(0,MAX_HALO_PLAYERS)
						if y == 0 and player1RCoord != [0,0,0]:
							x = player1RCoord
						if y == 1 and player2RCoord != [0,0,0]:
							x = player2RCoord
						if y == 2 and player3RCoord != [0,0,0]:
							x = player3RCoord
						if y == 3 and player4RCoord != [0,0,0]:
							x = player4RCoord
						if y == 4 and player5RCoord != [0,0,0]:
							x = player5RCoord
						if y == 5 and player6RCoord != [0,0,0]:
							x = player6RCoord
						if y == 6 and player7RCoord != [0,0,0]:
							x = player7RCoord
						if y == 7 and player8RCoord != [0,0,0]:
							x = player8RCoord
						if y == 8 and player9RCoord != [0,0,0]:
							x = player9RCoord
						if y == 9 and player10RCoord != [0,0,0]:
							x = player10RCoord
						if y == 10 and player11RCoord != [0,0,0]:
							x = player11RCoord
						if y == 11 and player12RCoord != [0,0,0]:
							x = player12RCoord
						if y == 12 and player13RCoord != [0,0,0]:
							x = player13RCoord
						if y == 13 and player14RCoord != [0,0,0]:
							x = player14RCoord
						if y == 14 and player15RCoord != [0,0,0]:
							x = player15RCoord
						if y == 15 and player16RCoord != [0,0,0]:
							x = player16RCoord
					
				
					if readUInt16(playerAddress + OFFSET_TO_PLAYER_VEHICLE_ID) == INVALID_PLAYER_OBJECT_ID:
						writeFloat(playerAddress + OFFSET_TO_PLAYER_X_COORDINATE,x[0])
						writeFloat(playerAddress + OFFSET_TO_PLAYER_Y_COORDINATE,x[1])
						writeFloat(playerAddress + OFFSET_TO_PLAYER_Z_COORDINATE,x[2])
						writeUTF16String(MOST_RECENT_MESSAGE_ADDRESS,"Teleporting " + readUTF16String(FIRST_STATIC_PLAYER_ADDRESS + STATIC_PLAYER_SIZE*playerIndex) + "...")
						writeToLog("Teleporting " + readUTF16String(FIRST_STATIC_PLAYER_ADDRESS + STATIC_PLAYER_SIZE*playerIndex) + "...")
					else:
						if ALLOW_VEHICLE_TELEPORTATION == 1:
							playerAddress = readUInt32(FIRST_TABLE_OBJECT_ADDRESS + OBJECT_TABLE_SIZE * readUInt16(playerAddress + OFFSET_TO_PLAYER_VEHICLE_ID) + OFFSET_TO_HALO_OBJECT_POINTER)
							writeFloat(playerAddress + OFFSET_TO_PLAYER_X_COORDINATE,x[0])
							writeFloat(playerAddress + OFFSET_TO_PLAYER_Y_COORDINATE,x[1])
							writeFloat(playerAddress + OFFSET_TO_PLAYER_Z_COORDINATE,x[2])
							writeUTF16String(MOST_RECENT_MESSAGE_ADDRESS,"Teleporting " + readUTF16String(FIRST_STATIC_PLAYER_ADDRESS + STATIC_PLAYER_SIZE*playerIndex) + " and friends in their vehicle...")
							writeToLog(readUTF16String(FIRST_STATIC_PLAYER_ADDRESS + STATIC_PLAYER_SIZE*playerIndex) + " and friends in their vehicle...")
						else:
							writeUTF16String(MOST_RECENT_MESSAGE_ADDRESS,"Unable to " + readUTF16String(FIRST_STATIC_PLAYER_ADDRESS + STATIC_PLAYER_SIZE*playerIndex) + " and friends in their vehicle. Vehicle teleportation is disabled.")
							writeToLog("Unable to " + readUTF16String(FIRST_STATIC_PLAYER_ADDRESS + STATIC_PLAYER_SIZE*playerIndex) + " and friends in their vehicle. Vehicle teleportation is disabled.")
def finish(timeElapsed, forcedShutDown):
	pass
	